//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop

#include "TSOServices.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TSOServices *)
{
	new TSOServices(NULL);
}
//---------------------------------------------------------------------------
__fastcall TSOServices::TSOServices(TComponent* Owner)
	: TComponent(Owner)
{

}
//---------------------------------------------------------------------------
namespace Tsoservices
{
	void __fastcall PACKAGE Register()
	{
		TComponentClass classes[1] = {__classid(TSOServices)};
		RegisterComponents(L"System Operations", classes, 0);
	}
}
//---------------------------------------------------------------------------

int TSOServices::GetCount()
{

	return this->SCount;

}

void TSOServices::GetInstalledServices(TStringList *AStrings)
{

	SC_HANDLE hSCManager = NULL;
	wchar_t lpServices[255] = {0};
	DWORD BufSize = 255;
	ENUM_SERVICE_STATUSW *lpService;
	DWORD BytesNeeded  = 0;
	DWORD dwSrvCount   = 0;
	DWORD ResumeHandle = 0;
	DWORD dwSrvType    = SERVICE_WIN32 | SERVICE_DRIVER | SERVICE_FILE_SYSTEM_DRIVER | SERVICE_KERNEL_DRIVER | SERVICE_WIN32_OWN_PROCESS | SERVICE_WIN32_SHARE_PROCESS;
	DWORD dwSrvState   = SERVICE_STATE_ALL;
    BOOL ReturnVal;

	if ( AStrings == NULL )
	{
		return;
	}

    AStrings->BeginUpdate();
	AStrings->Clear();
	this->SCount = 0;
	try
	{
		hSCManager = OpenSCManagerW(NULL, NULL, SC_MANAGER_ENUMERATE_SERVICE);
		if ( hSCManager == NULL )
		{
			return;
		}

		ReturnVal = EnumServicesStatusW(hSCManager, dwSrvType, dwSrvState, NULL, 0, &BytesNeeded, &dwSrvCount, &ResumeHandle);
		if ( ReturnVal == 0 )
		{

			DWORD dwBytes = BytesNeeded + sizeof(ENUM_SERVICE_STATUSW);
			lpService = new ENUM_SERVICE_STATUSW[dwBytes];
            EnumServicesStatusW(hSCManager, dwSrvType, dwSrvState, lpService, dwBytes, &BytesNeeded, &dwSrvCount, &ResumeHandle);

		}

		for (int i = 0; i < dwSrvCount; i++)
		{

			AStrings->Add( lpService->lpDisplayName );
			lpService++;
            this->SCount++;

		}

	}
	__finally
	{
		AStrings->EndUpdate();
		CloseServiceHandle(hSCManager);
	}

}

void TSOServices::GetInstalledServices(TStrings *AStrings)
{

	SC_HANDLE hSCManager = NULL;
	wchar_t lpServices[255] = {0};
	DWORD BufSize = 255;
	ENUM_SERVICE_STATUSW *lpService;
	DWORD BytesNeeded  = 0;
	DWORD dwSrvCount   = 0;
	DWORD ResumeHandle = 0;
	DWORD dwSrvType    = SERVICE_WIN32 | SERVICE_DRIVER | SERVICE_FILE_SYSTEM_DRIVER | SERVICE_KERNEL_DRIVER | SERVICE_WIN32_OWN_PROCESS | SERVICE_WIN32_SHARE_PROCESS;
	DWORD dwSrvState   = SERVICE_STATE_ALL;
    BOOL ReturnVal;

	if ( AStrings == NULL )
	{
		return;
	}

    AStrings->BeginUpdate();
	AStrings->Clear();
	this->SCount = 0;
	try
	{
		hSCManager = OpenSCManagerW(NULL, NULL, SC_MANAGER_ENUMERATE_SERVICE);
		if ( hSCManager == NULL )
		{
			return;
		}

		ReturnVal = EnumServicesStatusW(hSCManager, dwSrvType, dwSrvState, NULL, 0, &BytesNeeded, &dwSrvCount, &ResumeHandle);
		if ( ReturnVal == 0 )
		{

			DWORD dwBytes = BytesNeeded + sizeof(ENUM_SERVICE_STATUSW);
			lpService = new ENUM_SERVICE_STATUSW[dwBytes];
            EnumServicesStatusW(hSCManager, dwSrvType, dwSrvState, lpService, dwBytes, &BytesNeeded, &dwSrvCount, &ResumeHandle);

		}

		for (int i = 0; i < dwSrvCount; i++)
		{

			AStrings->Add( lpService->lpDisplayName );
			lpService++;
            this->SCount++;

		}

	}
	__finally
	{
		AStrings->EndUpdate();
		CloseServiceHandle(hSCManager);
	}

}

bool TSOServices::GetAServiceInfo(_SOSERVICESTRUCT *soServiceStruct)
{

    SC_HANDLE hSCManager = NULL;
	wchar_t lpServices[255] = {0};
	DWORD BufSize = 255;
	ENUM_SERVICE_STATUSW *lpService;
    SERVICE_STATUS ssServiceStatus;
	DWORD BytesNeeded  = 0;
	DWORD dwSrvCount   = 0;
	DWORD ResumeHandle = 0;
	DWORD dwSrvType    = SERVICE_WIN32 | SERVICE_DRIVER | SERVICE_FILE_SYSTEM_DRIVER | SERVICE_KERNEL_DRIVER | SERVICE_WIN32_OWN_PROCESS | SERVICE_WIN32_SHARE_PROCESS;
	DWORD dwSrvState   = SERVICE_STATE_ALL;
	BOOL ReturnVal;
	bool IsServiceExists = false;

	try
	{
		hSCManager = OpenSCManagerW(NULL, NULL, SC_MANAGER_ENUMERATE_SERVICE);
		if ( hSCManager == NULL )
		{
			return false;
		}

		ReturnVal = EnumServicesStatusW(hSCManager, dwSrvType, dwSrvState, NULL, 0, &BytesNeeded, &dwSrvCount, &ResumeHandle);
		if ( ReturnVal == 0 )
		{

			DWORD dwBytes = BytesNeeded + sizeof(ENUM_SERVICE_STATUSW);
			lpService = new ENUM_SERVICE_STATUSW[dwBytes];
            EnumServicesStatusW(hSCManager, dwSrvType, dwSrvState, lpService, dwBytes, &BytesNeeded, &dwSrvCount, &ResumeHandle);

		}

		for (int i = 0; i < dwSrvCount; i++)
		{

			if ( (wcscmp(soServiceStruct->lpServiceName, lpService->lpServiceName) == 0)
				|| (wcscmp(soServiceStruct->lpServiceName, lpService->lpDisplayName) == 0)
			)
			{
				IsServiceExists = true;
                break;
			}

			lpService++;

		}

		// Assign Values to Properties
		soServiceStruct->lpDisplayName 		 = lpService->lpDisplayName;
		soServiceStruct->lpServiceName       = lpService->lpServiceName;
		soServiceStruct->dwServiceType		 = lpService->ServiceStatus.dwServiceType;
		soServiceStruct->SCurrentState       = lpService->ServiceStatus.dwCurrentState;
		soServiceStruct->SControlsAccepted   = lpService->ServiceStatus.dwControlsAccepted;
		soServiceStruct->SWin32ExitCode      = lpService->ServiceStatus.dwWin32ExitCode;
		soServiceStruct->SSpecificExitCode   = lpService->ServiceStatus.dwServiceSpecificExitCode;
		soServiceStruct->SCheckPoint         = lpService->ServiceStatus.dwCheckPoint;
		soServiceStruct->SWaitHint           = lpService->ServiceStatus.dwWaitHint;

		// Get Type Name
		switch ( soServiceStruct->dwServiceType )
		{

			case SERVICE_FILE_SYSTEM_DRIVER: soServiceStruct->STypeName = "SERVICE_FILE_SYSTEM_DRIVER";
				break;
			case SERVICE_KERNEL_DRIVER: soServiceStruct->STypeName = "SERVICE_KERNEL_DRIVER";
				break;
			case SERVICE_WIN32_OWN_PROCESS: soServiceStruct->STypeName = "SERVICE_WIN32_OWN_PROCESS";
				break;
			case SERVICE_WIN32_SHARE_PROCESS: soServiceStruct->STypeName = "SERVICE_WIN32_SHARE_PROCESS";
				break;
			case SERVICE_USER_OWN_PROCESS: soServiceStruct->STypeName = "SERVICE_USER_OWN_PROCESS";
				break;
            case SERVICE_USER_SHARE_PROCESS: soServiceStruct->STypeName = "SERVICE_USER_SHARE_PROCESS";
				break;

		}

		// Get State Name
		switch ( soServiceStruct->SCurrentState )
		{

			case SERVICE_CONTINUE_PENDING: soServiceStruct->SCurrentStateName = "SERVICE_CONTINUE_PENDING";
				break;
			case SERVICE_PAUSE_PENDING: soServiceStruct->SCurrentStateName = "SERVICE_PAUSE_PENDING";
				break;
			case SERVICE_PAUSED: soServiceStruct->SCurrentStateName = "SERVICE_PAUSED";
				break;
			case SERVICE_RUNNING: soServiceStruct->SCurrentStateName = "SERVICE_RUNNING";
				break;
			case SERVICE_START_PENDING: soServiceStruct->SCurrentStateName = "SERVICE_START_PENDING";
				break;
			case SERVICE_STOP_PENDING: soServiceStruct->SCurrentStateName = "SERVICE_STOP_PENDING";
				break;
			case SERVICE_STOPPED: soServiceStruct->SCurrentStateName = "SERVICE_STOPPED";
				break;

		}

	}
	__finally
	{
		CloseServiceHandle(hSCManager);
	}

	return IsServiceExists;

}

SC_HANDLE TSOServices::InstallAService(wchar_t *AServicePath,
wchar_t *AServiceName, wchar_t *AServiceDisplayName, DWORD AServiceType)
{

	SC_HANDLE hSCManager = NULL;
	SC_HANDLE hService = NULL;
    DWORD dwErrorControl = 0;

	try
	{

		hSCManager = OpenSCManagerW(NULL, NULL, SC_MANAGER_CREATE_SERVICE);
		if ( hSCManager == NULL )
			return false;

		hService = CreateServiceW(hSCManager,
		AServiceName,
		AServiceDisplayName,
		SERVICE_ALL_ACCESS,
		AServiceType,
		SERVICE_AUTO_START,
		dwErrorControl,
		AServicePath, NULL, NULL, NULL, NULL, L"");

	}
	__finally
	{
		CloseServiceHandle(hSCManager);
	}

    return hService;

}

bool TSOServices::InstallAService(_SOSERVICESTRUCT *soServiceStruct)
{

	SC_HANDLE hSCManager = NULL;
	SC_HANDLE hService = NULL;
	bool IsInstalled = false;
	try
	{

		hSCManager = OpenSCManagerW(NULL, NULL, SC_MANAGER_CREATE_SERVICE);
		if ( hSCManager == NULL )
			return false;

		hService = CreateServiceW(
			hSCManager,
			soServiceStruct->lpServiceName,
			soServiceStruct->lpDisplayName,
			soServiceStruct->dwDesiredAccess,
			soServiceStruct->dwServiceType,
			soServiceStruct->dwStartType,
			soServiceStruct->dwErrorControl,
			soServiceStruct->lpBinaryPathName,
			soServiceStruct->lpLoadOrderGroup,
			soServiceStruct->lpdwTagId,
			soServiceStruct->lpDependencies,
			soServiceStruct->lpServiceStartName,
			soServiceStruct->lpPassword
		);

		if ( hService != NULL )
			IsInstalled = true;
		else
            IsInstalled = false;

	}
	__finally
	{
		CloseServiceHandle(hSCManager);
	}

    return IsInstalled;

}

bool TSOServices::UninstallAService(wchar_t *AServiceName)
{

	SC_HANDLE hSCManager = NULL;
	SC_HANDLE hService = NULL;
	BOOL IsServiceDeleted = false;

	try
	{

		hSCManager = OpenSCManagerW(NULL, NULL, SC_MANAGER_CONNECT);
		if ( hSCManager == NULL )
			return false;

		hService = OpenServiceW(hSCManager, AServiceName, DELETE);
		if ( hService == NULL )
			return false;

		IsServiceDeleted = DeleteService(hService);
		if ( !IsServiceDeleted )
			return false;

	}
	__finally
	{
		CloseServiceHandle(hSCManager);
		CloseServiceHandle(hService);
	}

	return IsServiceDeleted;

}

bool TSOServices::StartAServiceW(wchar_t *AServiceName)
{

	SC_HANDLE hSCManager = NULL;
	SC_HANDLE hService = NULL;
    BOOL IsServiceStarted = false;

	try
	{

		hSCManager = OpenSCManagerW(NULL, NULL, SC_MANAGER_CONNECT);
		if ( hSCManager == NULL )
			return false;

		hService = OpenServiceW(hSCManager, AServiceName, SERVICE_START);
		if ( hService == NULL )
			return false;

		IsServiceStarted = StartServiceW(hService, 0, NULL);
		if ( IsServiceStarted )
			IsServiceStarted = true;
		else
            IsServiceStarted = false;

	}
	__finally
	{
		CloseServiceHandle(hSCManager);
		CloseServiceHandle(hService);
	}

    return IsServiceStarted;

}

bool TSOServices::StopAServiceW(wchar_t *AServiceName)
{

	SC_HANDLE hSCManager = NULL;
	SC_HANDLE hService = NULL;
    _SERVICE_STATUS lpServiceStatus;
	BOOL IsServiceStopped = false;

	try
	{

		hSCManager = OpenSCManagerW(NULL, NULL, SC_MANAGER_CONNECT);
		if ( hSCManager == NULL )
			return false;

		hService = OpenServiceW(hSCManager, AServiceName, SERVICE_STOP);
		if ( hService == NULL )
			return false;

		IsServiceStopped = ControlService(hService, SERVICE_CONTROL_STOP, &lpServiceStatus);
		if ( IsServiceStopped )
			IsServiceStopped = true;
		else
            IsServiceStopped = false;

	}
	__finally
	{
		CloseServiceHandle(hSCManager);
		CloseServiceHandle(hService);
	}

	return IsServiceStopped;

}

bool TSOServices::PauseAServiceW(wchar_t *AServiceName)
{

	SC_HANDLE hSCManager = NULL;
	SC_HANDLE hService = NULL;
    _SERVICE_STATUS lpServiceStatus;
	BOOL IsServicePaused = false;

	try
	{

		hSCManager = OpenSCManagerW(NULL, NULL, SC_MANAGER_CONNECT);
		if ( hSCManager == NULL )
			return false;

		hService = OpenServiceW(hSCManager, AServiceName, SERVICE_PAUSE_CONTINUE);
		if ( hService == NULL )
			return false;

		IsServicePaused = ControlService(hService, SERVICE_CONTROL_PAUSE, &lpServiceStatus);
		if ( IsServicePaused )
			IsServicePaused = true;
		else
            IsServicePaused = false;

	}
	__finally
	{
		CloseServiceHandle(hSCManager);
		CloseServiceHandle(hService);
	}

	return IsServicePaused;

}

bool TSOServices::ResumeAServiceW(wchar_t *AServiceName)
{

	SC_HANDLE hSCManager = NULL;
	SC_HANDLE hService = NULL;
    _SERVICE_STATUS lpServiceStatus;
	BOOL IsServiceResumed = false;

	try
	{

		hSCManager = OpenSCManagerW(NULL, NULL, SC_MANAGER_CONNECT);
		if ( hSCManager == NULL )
			return false;

		hService = OpenServiceW(hSCManager, AServiceName, SERVICE_PAUSE_CONTINUE);
		if ( hService == NULL )
			return false;

		IsServiceResumed = ControlService(hService, SERVICE_CONTROL_CONTINUE, &lpServiceStatus);
		if ( IsServiceResumed )
			IsServiceResumed = true;
		else
            IsServiceResumed = false;

	}
	__finally
	{
		CloseServiceHandle(hSCManager);
		CloseServiceHandle(hService);
	}

	return IsServiceResumed;

}
