//---------------------------------------------------------------------------

#ifndef TSOServicesH
#define TSOServicesH
//---------------------------------------------------------------------------
#include <System.SysUtils.hpp>
#include <System.Classes.hpp>
//---------------------------------------------------------------------------

struct _SOSERVICESTRUCT
{

	DWORD dwDesiredAccess;
	DWORD dwServiceType;
	DWORD dwStartType;
	DWORD dwErrorControl;
    wchar_t *lpServiceName;
	wchar_t *lpDisplayName;
	wchar_t *lpBinaryPathName;
	wchar_t *lpLoadOrderGroup;
    wchar_t *lpDependencies;
	wchar_t *lpServiceStartName;
	wchar_t *lpPassword;
	LPDWORD lpdwTagId;

	DWORD SCurrentState;
    DWORD SControlsAccepted;
	DWORD SWin32ExitCode;
	DWORD SSpecificExitCode;
	DWORD SCheckPoint;
	DWORD SWaitHint;
	UnicodeString STypeName;
	UnicodeString SCurrentStateName;

};

class PACKAGE TSOServices : public TComponent
{
private:
	int SCount;
protected:
public:

    int GetCount();

    void GetInstalledServices(TStringList *AStrings);
	void GetInstalledServices(TStrings *AStrings);

	bool GetAServiceInfo(_SOSERVICESTRUCT *soServiceStruct);

	SC_HANDLE InstallAService(wchar_t *AServicePath, wchar_t *AServiceName, wchar_t *AServiceDisplayName,
	DWORD AServiceType = SERVICE_WIN32_OWN_PROCESS);
	bool InstallAService(_SOSERVICESTRUCT *soServiceStruct);

	bool UninstallAService(wchar_t *AServiceName);
	bool StartAServiceW(wchar_t *AServiceName);
	bool StopAServiceW(wchar_t *AServiceName);
	bool PauseAServiceW(wchar_t *AServiceName);
    bool ResumeAServiceW(wchar_t *AServiceName);

	__fastcall TSOServices(TComponent* Owner);
__published:
};

//---------------------------------------------------------------------------
#endif
